Index: /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 107)
@@ -804,39 +787,40 @@
 }
 
-/*
- * Lock transaction and set the value of Thread Local Storage.
- */
-static void lock_tsx(pjsip_transaction *tsx, struct tsx_lock_data *lck)
-{
-    struct tsx_lock_data *prev_data;
-
-    pj_mutex_lock(tsx->mutex);
-    prev_data = (struct tsx_lock_data *) 
-                    pj_thread_local_get(pjsip_tsx_lock_tls_id);
-    lck->prev = prev_data;
-    lck->tsx = tsx;
-    lck->is_alive = 1;
-    pj_thread_local_set(pjsip_tsx_lock_tls_id, lck);
-}
-
-
-/*
- * Unlock transaction.
- * This will selectively unlock the mutex ONLY IF the transaction has not been 
- * destroyed. The function knows whether the transaction has been destroyed
- * because when transaction is destroyed the is_alive flag for the transaction
- * will be set to zero.
- */
-static pj_status_t unlock_tsx( pjsip_transaction *tsx, 
-                               struct tsx_lock_data *lck)
-{
-    pj_assert( (void*)pj_thread_local_get(pjsip_tsx_lock_tls_id) == lck);
-    pj_assert( lck->tsx == tsx );
-    pj_thread_local_set(pjsip_tsx_lock_tls_id, lck->prev);
-    if (lck->is_alive)
-	pj_mutex_unlock(tsx->mutex);
-
-    return lck->is_alive ? PJ_SUCCESS : PJSIP_ETSXDESTROYED;
-}
+
+/* Destroy transaction. */
+static void tsx_destroy( pjsip_transaction *tsx )
+{
+    pj_mutex_destroy(tsx->mutex);
+    pjsip_endpt_release_pool(tsx->endpt, tsx->pool);
+}
+
+
+/*
+ * Callback when timer expires.
+ */
+static void tsx_timer_callback( pj_timer_heap_t *theap, pj_timer_entry *entry)
+{
+    pjsip_event event;
+    pjsip_transaction *tsx = entry->user_data;
+    struct tsx_lock_data lck;
+
+    PJ_UNUSED_ARG(theap);
+
+    PJ_LOG(5,(tsx->obj_name, "got timer event (%s timer)", 
+	     (entry->id==TSX_TIMER_RETRANSMISSION ? "Retransmit":"Timeout")));
+
+
+    if (entry->id == TSX_TIMER_RETRANSMISSION) {
+        PJSIP_EVENT_INIT_TIMER(event, &tsx->retransmit_timer);
+    } else {
+        PJSIP_EVENT_INIT_TIMER(event, &tsx->timeout_timer);
+    }
+
+    /* Dispatch event to transaction. */
+    lock_tsx(tsx, &lck);
+    (*tsx->state_handler)(tsx, &event);
+    unlock_tsx(tsx, &lck);
+}
+
 
 /*
@@ -848,6 +832,4 @@
                            void *event_src )
 {
-    pjsip_event e;
-
     PJ_LOG(4, (tsx->obj_name, "STATE %s-->%s, cause = %s",
 	       state_str[tsx->state], state_str[state], 
@@ -865,6 +847,10 @@
 
     /* Inform TU */
-    PJSIP_EVENT_INIT_TSX_STATE(e, tsx, event_src_type, event_src);
-    pjsip_endpt_send_tsx_event( tsx->endpt, &e  );
+    if (tsx->tsx_user && tsx->tsx_user->on_tsx_state) {
+	pjsip_event e;
+	PJSIP_EVENT_INIT_TSX_STATE(e, tsx, event_src_type, event_src);
+	(*tsx->tsx_user->on_tsx_state)(tsx, &e);
+    }
+    
 
     /* When the transaction is terminated, release transport, and free the
@@ -872,9 +858,8 @@
      */
     if (state == PJSIP_TSX_STATE_TERMINATED) {
+	pj_time_val timeout = {0, 0};
 
 	/* Decrement transport reference counter. */
-	if (tsx->transport && 
-            tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL) 
-        {
+	if (tsx->transport) {
 	    pjsip_transport_dec_ref( tsx->transport );
 	    tsx->transport = NULL;
@@ -896,12 +881,12 @@
 	}
 
-	/* If transport is not pending, reschedule timeout timer to
-	 * destroy this transaction.
-	 */
-	if (tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL) {
-	    pj_time_val timeout = {0, 0};
+	/* Reschedule timeout timer to destroy this transaction. */
+	if (tsx->transport_flag & TSX_HAS_PENDING_TRANSPORT) {
+	    tsx->transport_flag |= TSX_HAS_PENDING_DESTROY;
+	} else {
 	    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
 					&timeout);
 	}
+
 
     } else if (state == PJSIP_TSX_STATE_DESTROYED) {
@@ -915,180 +900,50 @@
 	    lck = lck->prev;
 	}
-    }
-}
-
-/*
- * Look-up destination address and select which transport to be used to send
- * the request message. The procedure used here follows the guidelines on 
- * sending the request in RFC3261 chapter 8.1.2.
- *
- * This function also modifies the message (request line and Route headers)
- * accordingly.
- */
-static pj_status_t tsx_process_route( pjsip_transaction *tsx,
-				      pjsip_tx_data *tdata,
-				      pjsip_host_info *send_addr )
-{
-    pjsip_route_hdr *route_hdr;
-    
-    pj_assert(tdata->msg->type == PJSIP_REQUEST_MSG);
-
-    /* Get the first "Route" header from the message. If the message doesn't
-     * have any "Route" headers but the endpoint has, then copy the "Route"
-     * headers from the endpoint first.
-     */
-    route_hdr = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, NULL);
-    if (!route_hdr) {
-	const pjsip_route_hdr *hdr_list;
-	const pjsip_route_hdr *hdr;
-	hdr_list = (const pjsip_route_hdr*)pjsip_endpt_get_routing(tsx->endpt);
-	hdr = hdr_list->next;
-	while (hdr != hdr_list {
-	    route_hdr = pjsip_hdr_shallow_clone(tdata->pool, hdr);
-	    pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)route_hdr);
-	    hdr = hdr->next;
-	}
-    }
-
-    return pjsip_get_request_addr(tdata, send_addr);  
-}
-
-
-/*
- * Callback from the transport job.
- * This callback is called when asychronous transport connect() operation
- * has completed, with or without error.
- */
-static void tsx_transport_callback(pjsip_transport *tr, 
-				   void *token, 
-				   pj_status_t status)
-{
-    char addr[PJ_MAX_HOSTNAME];
-    pjsip_transaction *tsx = token;
-    struct tsx_lock_data lck;
-
-    pj_memcpy(addr, tsx->dest_name.addr.host.ptr, tsx->dest_name.addr.host.slen);
-    addr[tsx->dest_name.addr.host.slen] = '\0';
-
-
-    if (status == PJ_SUCCESS) {
-	PJ_LOG(4, (tsx->obj_name, "%s connected to %s:%d",
-				  tr->type_name,
-				  addr, tsx->dest_name.addr.port));
-    } else {
-	PJ_LOG(4, (tsx->obj_name, "%s unable to connect to %s:%d, status=%d", 
-				  tr->type_name,
-				  addr, tsx->dest_name.addr.port, status));
-    }
-
-    /* Lock transaction. */
-    lock_tsx(tsx, &lck);
-
-    if (status != PJ_SUCCESS) {
-	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
-	tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-
-	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED,
-                      PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
-
-	/* Unlock transaction. */
-	unlock_tsx(tsx, &lck);
-	return;
-    }
-
-    /* See if transaction has already been terminated. 
-     * If so, schedule to destroy the transaction.
-     */
-    if (tsx->state == PJSIP_TSX_STATE_TERMINATED) {
-	pj_time_val timeout = {0, 0};
-	pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
-				    &timeout);
-
-	/* Unlock transaction. */
-	unlock_tsx(tsx, &lck);
-	return;
-    }
-
-    /* Add reference counter to the transport. */
-    pjsip_transport_add_ref(tr);
-
-    /* Mark transport as ready. */
-    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
-    tsx->transport = tr;
-
-    /* If there's a pending message to send, send it now. */
-    if (tsx->has_unsent_msg) {
-	tsx_send_msg( tsx, tsx->last_tx );
-    }
-
-    /* Unlock transaction. */
-    unlock_tsx(tsx, &lck);
-}
-
-/*
- * Callback from the resolver job.
- */
-static void tsx_resolver_callback(pj_status_t status,
-				  void *token,
-				  const struct pjsip_server_addresses *addr)
-{
-    pjsip_transaction *tsx = token;
-    struct tsx_lock_data lck;
-    pjsip_transport *tp;
-
-    PJ_LOG(4, (tsx->obj_name, "resolver job complete, status=%d", status));
-
-    if (status != PJ_SUCCESS || addr->count == 0) {
-	lock_tsx(tsx, &lck);
-	tsx->status_code = PJSIP_SC_TSX_RESOLVE_ERROR;
-	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, 
-                      PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
-	unlock_tsx(tsx, &lck);
-	return;
-    }
-
-    /* Lock transaction. */
-    lock_tsx(tsx, &lck);
-
-    /* Copy server addresses. */
-    pj_memcpy(&tsx->remote_addr, addr, sizeof(*addr));
-
-    /* Create/find the transport for the remote address. */
-    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_CONNECTING;
-    status = pjsip_endpt_alloc_transport( tsx->endpt, addr->entry[0].type,
-					  &addr->entry[0].addr,
-					  addr->entry[0].addr_len,
-					  &tp);
-    tsx_transport_callback(tp, tsx, status);
-
-    /* Unlock transaction */
-    unlock_tsx(tsx, &lck);
-
-    /* There should be nothing to do after this point.
-     * Execution for the transaction will resume when the callback for the 
-     * transport is called.
-     */
-}
-
-/*
- * Initialize the transaction as UAC transaction.
- */
-PJ_DEF(pj_status_t) pjsip_tsx_init_uac( pjsip_transaction *tsx, 
-					pjsip_tx_data *tdata)
-{
+
+	/* Unregister transaction. */
+	mod_tsx_layer_unregister_tsx(tsx);
+
+	/* Destroy transaction. */
+	tsx_destroy(tsx);
+    }
+}
+
+
+/*
+ * Create, initialize, and register UAC transaction.
+ */
+PJ_DEF(pj_status_t) pjsip_tsx_create_uac( pjsip_module *tsx_user,
+					  pjsip_tx_data *tdata,
+					  pjsip_transaction **p_tsx)
+{
+    pjsip_transaction *tsx;
     pjsip_msg *msg;
     pjsip_cseq_hdr *cseq;
     pjsip_via_hdr *via;
+    struct tsx_lock_data lck;
     pj_status_t status;
-    struct tsx_lock_data lck;
-
-    PJ_LOG(4,(tsx->obj_name, "initializing tsx as UAC (tdata=%p)", tdata));
+
+    PJ_ASSERT_RETURN(tdata!=NULL && p_tsx!=NULL, PJ_EINVAL);
+
+    /* Keep shortcut */
+    msg = tdata->msg;
+
+    /* Make sure CSeq header is present. */
+    cseq = pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
+    if (!cseq) {
+	pj_assert(!"CSeq header not present in outgoing message!");
+	return PJSIP_EMISSINGHDR;
+    }
+
+
+    /* Create transaction instance. */
+    status = tsx_create( tsx_user, &tsx);
+    if (status != PJ_SUCCESS)
+	return status;
+
 
     /* Lock transaction. */
     lock_tsx(tsx, &lck);
 
-    /* Keep shortcut */
-    msg = tdata->msg;
-
     /* Role is UAC. */
     tsx->role = PJSIP_ROLE_UAC;
@@ -1096,4 +951,7 @@
     /* Save method. */
     pjsip_method_copy( tsx->pool, &tsx->method, &msg->line.req.method);
+
+    /* Save CSeq. */
+    tsx->cseq = cseq->cseq;
 
     /* Generate Via header if it doesn't exist. */
@@ -1104,4 +962,5 @@
     }
 
+    /* Generate branch parameter if it doesn't exist. */
     if (via->branch_param.slen == 0) {
 	pj_str_t tmp;
@@ -1116,4 +975,5 @@
         /* Save branch parameter. */
         tsx->branch = via->branch_param;
+
     } else {
         /* Copy branch parameter. */
@@ -1121,26 +981,11 @@
     }
 
-
-    /* Generate transaction key. */
-    status = create_tsx_key_3261( tsx->pool, &tsx->transaction_key,
-			          PJSIP_ROLE_UAC, &tsx->method, 
-			          &via->branch_param);
-    if (status != PJ_SUCCESS) {
-        unlock_tsx(tsx, &lck);
-        return status;
-    }
+   /* Generate transaction key. */
+    create_tsx_key_3261( tsx->pool, &tsx->transaction_key,
+			 PJSIP_ROLE_UAC, &tsx->method, 
+			 &via->branch_param);
 
     PJ_LOG(6, (tsx->obj_name, "tsx_key=%.*s", tsx->transaction_key.slen,
 	       tsx->transaction_key.ptr));
-
-    /* Save CSeq. */
-    cseq = pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
-    if (!cseq) {
-	pj_assert(!"CSeq header not present in outgoing message!");
-        unlock_tsx(tsx, &lck);
-	return PJSIP_EMISSINGHDR;
-    }
-    tsx->cseq = cseq->cseq;
-
 
     /* Begin with State_Null.
@@ -1148,50 +993,32 @@
      */
     tsx->state = PJSIP_TSX_STATE_NULL;
-    tsx->state_handler = &pjsip_tsx_on_state_null;
-
-    /* Get destination name from the message. */
-    status = tsx_process_route(tsx, tdata, &tsx->dest_name);
-    if (status != PJ_SUCCESS) {
-	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
-	tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, 
-                      PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
-	unlock_tsx(tsx, &lck);
-	return status;
-    }
-
-    /* Resolve destination.
-     * This will start asynchronous resolver job, and when it finishes, 
-     * the callback will be called.
-     */
-    PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-			     tsx->dest_name.addr.host.slen, 
-			     tsx->dest_name.addr.host.ptr,
-			     tsx->dest_name.addr.port));
-
-    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
-    pjsip_endpt_resolve( tsx->endpt, tsx->pool, &tsx->dest_name, 
-			 tsx, &tsx_resolver_callback);
-
-    /* There should be nothing to do after this point. 
-     * Execution for the transaction will resume when the resolver callback is
-     * called.
-     */
-
-    /* Unlock transaction and return.
-     * If transaction has been destroyed WITHIN the current thread, the 
-     * unlock_tsx() function will return -1.
-     */
-    return unlock_tsx(tsx, &lck);
-}
-
-
-/*
- * Initialize the transaction as UAS transaction.
- */
-PJ_DEF(pj_status_t) pjsip_tsx_init_uas( pjsip_transaction *tsx, 
-					pjsip_rx_data *rdata)
-{
-    pjsip_msg *msg = rdata->msg_info.msg;
+    tsx->state_handler = &tsx_on_state_null;
+
+    /* Save the message. */
+    tsx->last_tx = tdata;
+    pjsip_tx_data_add_ref(tsx->last_tx);
+
+
+    /* Register transaction to hash table. */
+    mod_tsx_layer_register_tsx(tsx);
+
+
+    /* Unlock transaction and return. */
+    unlock_tsx(tsx, &lck);
+
+    *p_tsx = tsx;
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Create, initialize, and register UAS transaction.
+ */
+PJ_DEF(pj_status_t) pjsip_tsx_create_uas( pjsip_module *tsx_user,
+					  pjsip_rx_data *rdata,
+					  pjsip_transaction **p_tsx)
+{
+    pjsip_transaction *tsx;
+    pjsip_msg *msg;
     pj_str_t *branch;
     pjsip_cseq_hdr *cseq;
@@ -1199,12 +1026,33 @@
     struct tsx_lock_data lck;
 
-    PJ_LOG(4,(tsx->obj_name, "initializing tsx as UAS (rdata=%p)", rdata));
+    PJ_ASSERT_RETURN(rdata!=NULL && p_tsx!=NULL, PJ_EINVAL);
+
+    /* Keep shortcut to message */
+    msg = rdata->msg_info.msg;
+    
+    /* Make sure this is a request message. */
+    PJ_ASSERT_RETURN(msg->type == PJSIP_REQUEST_MSG, PJSIP_ENOTREQUESTMSG);
+
+    /* Make sure CSeq header is present. */
+    cseq = rdata->msg_info.cseq;
+    if (!cseq)
+	return PJSIP_EMISSINGHDR;
+
+    /* Make sure Via header is present. */
+    if (rdata->msg_info.via == NULL)
+	return PJSIP_EMISSINGHDR;
+
+
+    /* 
+     * Create transaction instance. 
+     */
+    status = tsx_create( tsx_user, &tsx);
+    if (status != PJ_SUCCESS)
+	return status;
+
 
     /* Lock transaction. */
     lock_tsx(tsx, &lck);
 
-    /* Keep shortcut to message */
-    msg = rdata->msg_info.msg;
-
     /* Role is UAS */
     tsx->role = PJSIP_ROLE_UAS;
@@ -1212,4 +1060,7 @@
     /* Save method. */
     pjsip_method_copy( tsx->pool, &tsx->method, &msg->line.req.method);
+
+    /* Save CSeq */
+    tsx->cseq = cseq->cseq;
 
     /* Get transaction key either from branch for RFC3261 message, or
@@ -1219,5 +1070,5 @@
                                   PJSIP_ROLE_UAS, &tsx->method, rdata);
     if (status != PJ_SUCCESS) {
-        unlock_tsx(tsx, &lck);
+        tsx_destroy(tsx);
         return status;
     }
@@ -1230,208 +1081,57 @@
 	       tsx->transaction_key.ptr));
 
-    /* Save CSeq */
-    cseq = rdata->msg_info.cseq;
-    tsx->cseq = cseq->cseq;
-
-    /* Begin with state NULL
+
+    /* Begin with state TRYING.
      * Manually set-up the state becase we don't want to call the callback.
      */
-    tsx->state = PJSIP_TSX_STATE_NULL; 
-    tsx->state_handler = &pjsip_tsx_on_state_null;
-
-    /* Get the transport to send the response. 
-     * According to section 18.2.2 of RFC3261, if the transport is reliable
-     * then the response must be sent using that transport.
+    tsx->state = PJSIP_TSX_STATE_TRYING; 
+    tsx->state_handler = &tsx_on_state_trying;
+
+    /* Get response address. */
+    status = pjsip_get_response_addr( tsx->pool, rdata, &tsx->res_addr );
+    if (status != PJ_SUCCESS) {
+	tsx_destroy(tsx);
+	return status;
+    }
+
+    /* If it's decided that we should use current transport, keep the
+     * transport.
      */
-    /* In addition, RFC 3581 says, if Via has "rport" parameter specified,
-     * then return the response using the same transport.
-     */
-    if (PJSIP_TRANSPORT_IS_RELIABLE(rdata->tp_info.transport) || 
-	rdata->msg_info.via->rport_param >= 0) 
-    {
-	tsx->transport = rdata->tp_info.transport;
+    if (tsx->res_addr.transport) {
+	tsx->transport = tsx->res_addr.transport;
 	pjsip_transport_add_ref(tsx->transport);
-	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
-
-	tsx->current_addr = 0;
-	tsx->remote_addr.count = 1;
-	tsx->remote_addr.entry[0].type = tsx->transport->key.type;
-	pj_memcpy(&tsx->remote_addr.entry[0].addr, 
-		  &rdata->pkt_info.src_addr, rdata->pkt_info.src_addr_len);
-	
-    } else {
-	pj_status_t status;
-
-	status = pjsip_get_response_addr(tsx->pool, rdata->tp_info.transport,
-					 rdata->msg_info.via, &tsx->dest_name);
-	if (status != PJ_SUCCESS) {
-	    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
-	    tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-	    tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, 
-                          PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
-	    unlock_tsx(tsx, &lck);
-	    return status;
-	}
-
-	/* Resolve destination.
-	 * This will start asynchronous resolver job, and when it finishes, 
-	 * the callback will be called.
-	 */
-	PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-				 tsx->dest_name.addr.host.slen, 
-				 tsx->dest_name.addr.host.ptr,
-				 tsx->dest_name.addr.port));
-
-	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
-	pjsip_endpt_resolve( tsx->endpt, tsx->pool, &tsx->dest_name, 
-			     tsx, &tsx_resolver_callback);
-    }
-    
-    /* There should be nothing to do after this point. 
-     * Execution for the transaction will resume when the resolver callback is
-     * called.
-     */
-
-    /* Unlock transaction and return.
-     * If transaction has been destroyed WITHIN the current thread, the 
-     * unlock_tsx() function will return -1.
-     */
-    return unlock_tsx(tsx, &lck);
-}
-
-/*
- * Callback when timer expires.
- */
-static void tsx_timer_callback( pj_timer_heap_t *theap, pj_timer_entry *entry)
-{
-    pjsip_event event;
-    pjsip_transaction *tsx = entry->user_data;
+	pj_memcpy(&tsx->addr, &tsx->res_addr.addr, tsx->res_addr.addr_len);
+	tsx->addr_len = tsx->res_addr.addr_len;
+    }
+
+
+    /* Register the transaction. */
+    mod_tsx_layer_register_tsx(tsx);
+
+
+    /* Unlock transaction and return. */
+    unlock_tsx(tsx, &lck);
+
+    *p_tsx = tsx;
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Forcely terminate transaction.
+ */
+PJ_DEF(pj_status_t) pjsip_tsx_terminate( pjsip_transaction *tsx, int code )
+{
     struct tsx_lock_data lck;
 
-    PJ_UNUSED_ARG(theap);
-
-    PJ_LOG(5,(tsx->obj_name, "got timer event (%s timer)", 
-	     (entry->id==TSX_TIMER_RETRANSMISSION ? "Retransmit" : "Timeout")));
-
-
-    if (entry->id == TSX_TIMER_RETRANSMISSION) {
-        PJSIP_EVENT_INIT_TIMER(event, &tsx->retransmit_timer);
-    } else {
-        PJSIP_EVENT_INIT_TIMER(event, &tsx->timeout_timer);
-    }
-
-    /* Dispatch event to transaction. */
+    PJ_ASSERT_RETURN(tsx != NULL, PJ_EINVAL);
+    PJ_ASSERT_RETURN(code >= 200, PJ_EINVAL);
+
     lock_tsx(tsx, &lck);
-    (*tsx->state_handler)(tsx, &event);
+    tsx->status_code = code;
+    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, PJSIP_EVENT_USER, NULL);
     unlock_tsx(tsx, &lck);
-}
-
-/*
- * Transmit ACK message for 2xx/INVITE with this transaction. The ACK for
- * non-2xx/INVITE is automatically sent by the transaction.
- * This operation is only valid if the transaction is configured to handle ACK
- * (tsx->handle_ack is non-zero). If this attribute is not set, then the
- * transaction will comply with RFC-3261, i.e. it will set itself to 
- * TERMINATED state when it receives 2xx/INVITE.
- */
-PJ_DEF(void) pjsip_tsx_on_tx_ack( pjsip_transaction *tsx, pjsip_tx_data *tdata)
-{
-    pjsip_msg *msg;
-    pjsip_host_info dest_addr;
-    pjsip_via_hdr *via;
-    struct tsx_lock_data lck;
-    pj_status_t status = PJ_SUCCESS;
-
-    /* Lock tsx. */
-    lock_tsx(tsx, &lck);
-
-    pj_assert(tsx->handle_ack != 0);
-    
-    msg = tdata->msg;
-
-    /* Generate branch parameter if it doesn't exist. */
-    via = pjsip_msg_find_hdr(msg, PJSIP_H_VIA, NULL);
-    if (via == NULL) {
-	via = pjsip_via_hdr_create(tdata->pool);
-	pjsip_msg_add_hdr(msg, (pjsip_hdr*) via);
-    }
-
-    if (via->branch_param.slen == 0) {
-	via->branch_param = tsx->branch;
-    } else {
-	pj_assert( pj_strcmp(&via->branch_param, &tsx->branch) == 0 );
-    }
-
-    /* Get destination name from the message. */
-    status = tsx_process_route(tsx, tdata, &dest_addr);
-    if (status != 0){
-	goto on_error;
-    }
-
-    /* Compare message's destination name with transaction's destination name.
-     * If NOT equal, then we'll have to resolve the destination.
-     */
-    if (dest_addr.type == tsx->dest_name.type &&
-	dest_addr.flag == tsx->dest_name.flag &&
-	dest_addr.addr.port == tsx->dest_name.addr.port &&
-	pj_stricmp(&dest_addr.addr.host, &tsx->dest_name.addr.host) == 0)
-    {
-	/* Equal destination. We can use current transport. */
-	pjsip_tsx_on_tx_msg(tsx, tdata);
-	unlock_tsx(tsx, &lck);
-	return;
-
-    }
-
-    /* New destination; we'll have to resolve host and create new transport. */
-    pj_memcpy(&tsx->dest_name, &dest_addr, sizeof(dest_addr));
-    pj_strdup(tsx->pool, &tsx->dest_name.addr.host, &dest_addr.addr.host);
-
-    PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-			     tsx->dest_name.addr.host.slen, 
-			     tsx->dest_name.addr.host.ptr,
-			     tsx->dest_name.addr.port));
-
-    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
-    pjsip_transport_dec_ref(tsx->transport);
-    tsx->transport = NULL;
-
-    /* Put the message in queue. */
-    pjsip_tsx_on_tx_msg(tsx, tdata);
-
-    /* This is a bug!
-     * We shouldn't change transaction's state before actually sending the
-     * message. Otherwise transaction will terminate before message is sent,
-     * and timeout timer will be scheduled.
-     */
-    PJ_TODO(TSX_DONT_CHANGE_STATE_BEFORE_SENDING_ACK)
-
-    /* 
-     * This will start asynchronous resolver job, and when it finishes, 
-     * the callback will be called.
-     */
-
-    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
-    pjsip_endpt_resolve( tsx->endpt, tsx->pool, &tsx->dest_name, 
-			 tsx, &tsx_resolver_callback);
-
-    unlock_tsx(tsx, &lck);
-
-    /* There should be nothing to do after this point. 
-     * Execution for the transaction will resume when the resolver callback is
-     * called.
-     */
-    return;
-
-on_error:
-    /* Failure condition. 
-     * Send TERMINATED event.
-     */
-    tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-
-    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
-                   PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
-
-    unlock_tsx(tsx, &lck);
+
+    return PJ_SUCCESS;
 }
 
@@ -1440,10 +1140,15 @@
  * This function is called by TU to send a message.
  */
-PJ_DEF(void) pjsip_tsx_on_tx_msg( pjsip_transaction *tsx,
-				  pjsip_tx_data *tdata )
+PJ_DEF(pj_status_t) pjsip_tsx_send_msg( pjsip_transaction *tsx, 
+				        pjsip_tx_data *tdata )
 {
     pjsip_event event;
     struct tsx_lock_data lck;
     pj_status_t status;
+
+    if (tdata == NULL)
+	tdata = tsx->last_tx;
+
+    PJ_ASSERT_RETURN(tdata != NULL, PJ_EINVALIDOP);
 
     PJ_LOG(5,(tsx->obj_name, "Request to transmit msg on state %s (tdata=%p)",
@@ -1456,5 +1161,8 @@
     status = (*tsx->state_handler)(tsx, &event);
     unlock_tsx(tsx, &lck);
-}
+
+    return status;
+}
+
 
 /*
@@ -1462,6 +1170,5 @@
  * transaction is received.
  */
-PJ_DEF(void) pjsip_tsx_on_rx_msg( pjsip_transaction *tsx,
-				  pjsip_rx_data *rdata)
+static void tsx_on_rx_msg( pjsip_transaction *tsx, pjsip_rx_data *rdata)
 {
     pjsip_event event;
@@ -1472,4 +1179,8 @@
 	      state_str[tsx->state], rdata));
 
+    /* Put the transaction in the rdata's mod_data. */
+    rdata->endpt_info.mod_data[mod_tsx_layer.mod.id] = tsx;
+
+    /* Init event. */
     PJSIP_EVENT_INIT_RX_MSG(event, tsx, rdata);
 
